{******************************************************************************

襭 ⥬  ࠨ᪨ ࠢ ()
⮤ . 롮 饣   ⮫ v. 1.0

(c) 2002 ⠭᫠               <xstazz@hotbox.ru>

ணࠬ ࠡ             http://vt.spbgmtu.ru

******************************************************************************}

uses crt;

const
   MAX_SIZE=20;                          {ᨬ ࠧ }

type
   TMatrix = array [1..MAX_SIZE] of array [1..MAX_SIZE+1] of double;
   TVector = array [1..MAX_SIZE] of double;
var
   a: TMatrix;
   x: TVector;
   n, i, j: integer;
   data_file: text;
   result_file: text;

{ ப }
procedure swapRow(var a: TMatrix;
                  n: integer;
                  i1: integer;
                  i2: integer);
var
   j: integer;
   t: double;
begin
   for j:=1 to n+1 do begin
      t := a[i1,j];
      a[i1,j] := a[i2,j];
      a[i2,j] := t;
   end
end;


{襭  ⮤ }
procedure linearSolveGaussColLead(a: TMatrix;     {७  .}
                                  var x: TVector; {१}
                                  n: integer);
var
   i, j, k: integer;
   max, lead, a_div_lead, sum, eps: double;
   max_i : integer;

begin
   eps := 0.000001;

   {אַ 室}
   for k:=1 to n do begin
      { ᨬ쭮     ⮫}
      max := 0;
      max_i := -1;

      for i:=k to n do begin
	 if(abs(a[i,k]) > max) then begin
	    max := abs(a[i,k]);
	    max_i := i;
         end;
      end;

      if((max_i = -1) or (abs(a[max_i,k])<eps)) then begin
	 writeln('訡: ।⥫ ࠢ ');
      end
      else begin
	 if(max_i <> k) then begin
	    { ப}
	    swapRow(a,n,max_i,k);
         end;
      end;

      {㫥 ⮢}
      lead := a[k,k];

      for j:=k to n+1 do begin
	 a[k,j] := a[k,j]/lead;
      end;

      for i:=k+1 to n do begin
	 a_div_lead := a[i,k]/a[k,k];

	 for j:=k to n+1 do begin
	    a[i,j] := a[i,j]-a[k,j]*a_div_lead;
	 end;
      end;
   end;

   { 室}
   x[n] := a[n][n+1];

   for k:=n-1 downto 1 do begin
      sum := a[k][n+1];

      for j:=k+1 to n do begin
	 sum := sum-a[k,j]*x[j];
      end;

      x[k] := sum;
   end;
end;


begin
   clrscr;
   writeln('襭 ⥬  ࠨ᪨ ࠢ');
   writeln('⮤ . 롮 饣   ⮫');
   writeln;

   assign(data_file, 'a.txt');
   reset(data_file);
   read(data_file, n);

   for i:=1 to n do begin
      for j:=1 to n+1 do begin
         read(data_file, a[i,j]);
      end;
   end;

   close(data_file);

   writeln('७  ⥬:');
   for i:=1 to n do begin
      for j:=1 to n+1 do begin
         write(a[i,j]:14:6);
      end;
      writeln;
   end;
   writeln;

   linearSolveGaussColLead(a,x,n);

   writeln(':');
   for i:=1 to n do begin
      writeln(x[i]:14:6);
   end;
   writeln;

   assign(result_file, 'result.txt');
   rewrite(result_file);

   for i:=1 to n do begin
      writeln(result_file, x[i]:14:6);
   end;

   close(result_file);

   readkey;
end.